<template>
<div>
 <roles-heading :title="username" :logged="false"/>
  <v-main>
    <v-row>
      <v-col v-if="!tokenExpired">
        <v-row justify="center">
          <v-col md="6" cols="12">
            <div class="box">
              <!-- TITULO Y BIENVENIDA -->
              <v-row justify="center">Coloca tu nueva contraseña para ingresar al</v-row>
              <v-row justify="center"><strong>Sistema de Tutoría</strong></v-row>
              <!-- FORMULARIO PARA PASSWORD -->
              <v-row justify="center">
                <v-form ref="form" v-model="valid">
                  <div class="fields">
                    <v-text-field
                      v-model="fields.password.value"
                      :rules="fields.password.rules"
                      :label="fields.password.label"
                      :type="fields.password.type"
                      required
                    />
                    <v-text-field
                      v-model="fields.confirmPassword.value"
                      :rules="fields.confirmPassword.rules"
                      :label="fields.confirmPassword.label"
                      :type="fields.confirmPassword.type"
                      required
                    />
                  </div>
                  <st-primary-btn class="block" :loading="loading" @click="confirm" nombre="Confirmar correo y contraseña"/>
                </v-form>
              </v-row>
              <!-- AVISO DE RESULTADO -->
              <v-dialog v-model="dialog" max-width="390">
                <v-card>
                  <v-card-title>{{ card.title }}</v-card-title>
                  <v-card-text>{{ card.text }}</v-card-text>
                  <v-card-actions class="pb-5">
                    <v-row justify="center">
                      <st-primary-btn link="/" nombre="Ir al Login"/>
                    </v-row>
                  </v-card-actions>
                </v-card>
              </v-dialog>
            </div>
          </v-col>
        </v-row>
      </v-col>
      <!-- TOKEN EXPIRADO -->
      <v-col v-else>
        <v-row justify="center">
          <v-row justify="center">El link para el último pase de registro ha expirado</v-row>
          <div class="emptyRol"><v-img src="/images/planta.png"></v-img></div>
        </v-row>
      </v-col>
    </v-row>
  </v-main>
</div>
</template>

<script>
import RolesHeading from '@/components/TheRolesHeading.vue'
import Modal from '@/components/Modal.vue'
import tokenTool from "../../assets/js/token-tool";

  export default {
    layout:'simple',
    name: "Confirmation",
    components:{
      'roles-heading': RolesHeading,
      'modal':Modal
    },
    data() { return {
      card:{
        title:'Confirmación',
        text: 'Se ha confirmado tu correo electrónico con la contraseña elegida. Ahora podrás acceder al Sistema de Tutoría'
      },
      dialog:false,
      expDate: null,
      exp: null,
      username: '',
      valid: true,
      loading: false,
      fields:{
        password:{
          value: '',
          label: 'Contraseña',
          type: 'password',
          rules: [
            v => !!v || 'La contraseña es requerida',
            v => v.length >= 6 || 'La contraseña debe ser mayor o igual a 6 caracteres',
          ],
        },
        confirmPassword:{
          value: '',
          label: 'Confirmar contraseña',
          type: 'password',
          rules: [
            v => !!v || 'La contraseña es requerida',
            v => v === this.fields.password.value || 'Las contraseñas no coinciden',
          ],
        },
      },
    }},
    computed: {
      tokenExpired() {
        let now = new Date()
        let notValid = now > this.expDate
        return notValid
      }
    },
    methods: {
      async confirm() {
        this.$refs.form.validate();
        if (this.valid) {
          try {
            this.loading = true;
            const password = this.fields.password.value;
            let { data: { message } } = await this.$api.confirmUser({token: this.$route.params.token, contrasenia: password});
            this.dialog=true
          }
          catch(e) {
            this.dialog = true
            this.card.title = 'Error'
            if (e.response) this.card.text = e.response.data.message
          }
          this.loading = false;
        }
      }
    },
    created() {
      const tokenPayload = tokenTool.getPayload(this.$route.params.token);
      if (tokenPayload) {
        this.username = tokenPayload.usuario;
        this.exp = tokenPayload.exp;
        this.expDate = new Date(tokenPayload.expFormat);
      } else {
        this.$router.push('/');
      }
    }
  }
</script>

<style scoped>
  .container.fill-height{
    align-items:baseline
  }

  .emptyRol{
    max-width:80px;
    margin:80px 0;
  }

  .fields{
    margin-top:40px;
    margin-bottom:60px;
  }
  .block{
    margin-top:10px;
    width:100%;
  }
  .two{
    background-color:#F2F2F2 !important;
    color:#505050 !important;
  }
  .caption{
    text-align: center;
  }
  .box{
    max-width:700px
  }

</style>
